/*
 * Copyright 2002
 *  Bob Shaffer II
 *  4517 West Melissa Court
 *  Jacksonville, Florida 32210
 *  United States of America
 * All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 */

#ifndef cgi_query_h_included
#define cgi_query_h_included 1

#include "textfiles.h"

using namespace std;

class cgi_query {
   friend class std::istream;
   public:
   cgi_query(int Auto=0);
   cgi_query(const char *cstring);
   string VarName(long column);
   string Value(long column);
   string GetVar(char *VName);
   long length();
   private:
   void Restore_Spaces(string &S);
   vector<Delimited_Row> Var_Val_Pairs;
};

istream &operator>>(istream &in, cgi_query &MyQuery);

#endif

