/*
 * Copyright 2002
 *  Bob Shaffer II
 *  4517 West Melissa Court
 *  Jacksonville, Florida 32210
 *  United States of America
 * All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 */

#include "multipart_cgi_query.h"
/*
#include <iostream>
#include <vector>
#include <string>
#include <cstdlib>

typedef struct {
    string Name, Value;
} name_value_pair;

class multipart_cgi_query {
    public:
    multipart_cgi_query();
    string GetVar(char *VarName);
    private:
    vector<name_value_pair> Pairs;
}
*/

// using namespace std;

multipart_cgi_query::multipart_cgi_query() {
    string Temp, BoundStr;
    name_value_pair nvPair;
    char C; unsigned long L, B, m;
    getline(cin, BoundStr); 
    if (cin.eof()) return;
    BoundStr.erase(BoundStr.length()-1);
    B=BoundStr.length();

//    cerr<<"BoundStr=\'"<<BoundStr<<"\'.\n"; cerr.flush();

    for (;;) {
//        cerr<<"Parsing part "<<Pairs.size()+1<<endl;
        getline(cin, Temp); 
        if (cin.eof()) { cerr<<"Unexpected EOF while parsing multipart query.\n"; return; }
	Temp.erase(Temp.length()-1);
        nvPair.Name="";
        nvPair.Value="";
        // Should be "Content-Disposition..."

//        cerr<<"Getting Name:\'"; cerr.flush();

        for (int a=38; Temp[a]!='\"'; ++a) {
            nvPair.Name+=Temp[a];
            cerr<<Temp[a];
        }

//        cerr<<"\' (Got \'"<<nvPair.Name<<"\').\n"; cerr.flush();

        do {
            getline(cin, Temp);
            if (cin.eof()) { cerr<<"Unexpected EOF while parsing multipart query.\n"; return; }
            Temp.erase(Temp.length()-1);
        } while (Temp.length()>0);
        L=0; // content-part length
        for (;;) {
            cin.get(C);
            if (cin.eof()) { cerr<<"Unexpected EOF while parsing multipart query.\n"; return; }
            nvPair.Value+=C; ++L;
            if (L>=B) {
//                if (string(Pair.Value, L-BoundStr.length(), BoundStr.length()) == BoundStr) {
//                    Pair.Value.erase(L-BoundStr.length()-1, BoundStr.length()+1);
                for (m=0; m<B; ++m) {
                    if (BoundStr[m]!=nvPair.Value[L-B+m]) break;
                }
                // if m==B, we hit the end
                if (m==B) {
                    nvPair.Value.erase(L-B-2, B+2);
                    break; // this should get us out of this loop (***)
                }
            }
        }
        // (***) and down to save that and get the next part

//        cerr<<"finished retrieving Value ("<<nvPair.Value.length()<<" bytes).\n"; cerr.flush();

        Pairs.push_back(nvPair);
        getline(cin, Temp); Temp.erase(Temp.length()-1);
        if (Temp==string("--")) break; // no more parts
    }
} // end constructor

string multipart_cgi_query::GetVar(char *VarName) {
    for (long a=0; a<Pairs.size(); ++a) if (Pairs[a].Name==string(VarName)) return Pairs[a].Value;
    return string("");
}


