/*
 * Copyright 2002
 *  Bob Shaffer II
 *  4517 West Melissa Court
 *  Jacksonville, Florida 32210
 *  United States of America
 * All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 */

#ifndef MULTIPART_CGI_QUERY_INCLUDED
#define MULTIPART_CGI_QUERY_INCLUDED 1

#include <iostream>
#include <vector>
#include <string>
#include <cstdlib>

using namespace std;

typedef struct {
    string Name, Value;
} name_value_pair;

class multipart_cgi_query {
    public:
    multipart_cgi_query();
    string GetVar(char *VarName);
    private:
    vector<name_value_pair> Pairs;
};



#endif

